package irnatura.offline;

import irnatura.offline.TempForwardIterator;
import java.util.TreeMap;

public class Hotspots
{
    // Threshold: negative == .1%, positive == .01C
    public static int getHotMin(TempProfile tp, int threshold)
    {
        if (threshold > 0)
            return tp.getMax() - threshold;
        return Math.round((float)((-threshold) * (tp.getMax() - tp.getMin()))
                            / 1000.0f);
    }

    public static class HotBounds
    {
        public int cnt;
        public int lbx;
        public int ubx;
        public int lby;
        public int uby;
        public HotBounds(int width, int height)
        {
            int cnt = 0;
            int lbx = width;
            int ubx = 0;
            int lby = height;
            int uby = 0;
        }
    }
    
    public static HotBounds getHotBounds(TempForwardIterator it, int mintemp)
    {
        HotBounds hb = new HotBounds(it.getWidth(), it.getHeight());
        for (int h = 0; h < it.getHeight(); ++h) {
            for (int w = 0; w < it.getWidth(); ++w) {
                if (it.getTemp(w, h) >= mintemp) {
                    ++hb.cnt;
                    if (hb.lbx > w) hb.lbx = w;
                    if (hb.ubx < w) hb.ubx = w;
                    if (hb.lby > h) hb.lby = h;
                    if (hb.uby < h) hb.uby = h;
                }
            }
        }
        return hb;
    }

    // Try dimthresh = 36 and cntthresh = 36
    public static boolean isHot(HotBounds hb, int dimthresh, int cntthresh)
    {
        return hb.cnt <= cntthresh
            && hb.lbx <= hb.ubx && (hb.ubx - hb.lbx <= dimthresh)
            && hb.lby <= hb.uby && (hb.uby - hb.lby <= dimthresh)
            ;
    }

    /*
    public static int countHotTiles(
            TempForwardIterator it, TempProfile tp, int threshold, int tiledim)
    {
        int num_hot_tiles = 0;
        int [] tilerow = new int[(it.getWidth() + tiledim - 1) / tiledim];
        for (int h = 0; h < it.getHeight(); ++h) {
            if ( h != 0 && h % tiledim == 0) {
            }
            for (int w = 0; w < it.getWidth(); ++w) {
            }
        }
    }
    */
}
