package irnatura.online;

import irnatura.offline.ImageWrap;
import android.graphics.Bitmap;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.lang.System;
import java.nio.IntBuffer;

public class ColoredBitmap
{
    ImageWrap m_img;
    Bitmap m_bm;

    public void setImage(ImageWrap img)
    {
        m_img = img;
    }

    public Bitmap getBitmap()
    {
		m_bm = Bitmap.createBitmap(m_img.getWidth(), m_img.getHeight(),
				                   Bitmap.Config.ARGB_8888);
        int [] line = new int[m_img.getWidth()];
        for (int h = 0; h < m_img.getHeight(); ++h) {
            for (int w = 0; w < m_img.getWidth(); ++w) {
                // TODO
                line[w] = m_img.getTemp(w, h);
                m_bm.copyPixelsFromBuffer(IntBuffer.wrap(line));
            }
        }
        return m_bm;
    }

    public void writeJpg(File outfile)
    {
        Bitmap bm = getBitmap();
        try {
            OutputStream os = new BufferedOutputStream(
                              new FileOutputStream(outfile));
            if (!bm.compress(Bitmap.CompressFormat.JPEG, 90, os))
                System.out.println("Compression error");
        }
        catch (java.io.FileNotFoundException e) {
            System.out.println(e.getMessage());
        }
    }
}
